var ddl_questionId=0;
var host="";

function handleQuestionStateMessage(data) {
	/*
	* 1 待处理状态
	* 2 处理中
	* 3 处理完成
	* 4 订单关闭
	* 5 确认查看关闭
	* 15 未提交过工单
	*/	
	$("#ErrorPage").hide();
	
	message=data["message"];
	
	if(message=="1") {
		// alert("修改问题 && 取消工单");
		$("#QuestionState1Page").show();
	} else if(message=="2") {
		// alert("处理中 显示");
		$("#QuestionState2Page").show();
		window.location="ddl://getQuestionReply";
	} else if(message=="3") {
		// alert("处理完成 显示 继续提问");
		$("#QuestionPage").show();
		$("#btnSend").show();
	} else if(message=="4") {
		// alert("订单关闭 是否已经确认查看");
		$("#QuestionState4Page").show();
		$("#CloseMessage").text(data["detailmsg"]);
	} else if(message=="5") {
		// alert("确认查看关闭");
		$("#QuestionPage").show();
		$("#btnSend").show();
	} else if(message=="15") {
		// alert("未提交过工单");
		$("#QuestionPage").show();
		$("#btnSend").show();
	}
	
}

function handleQuestionSubmitMessage(message) { 
	if(message=="1") {
		// alert("提交成功 & 待处理状态");
		$("#QuestionState1Page").show();
	} 
}

///设置图片URL(ios wp android)
function setPicture(dataURL) {
	
	$("#imgPicture").hide();
	
	if(dataURL=='img/img.png') {
		$("#imgPicture").attr("src",dataURL);
	} else {
		$("#imgPicture").attr("src",host+dataURL);
	}	
	
	$("#imgPicture").show();
}

function fillQuestion(qid,qtitle,qContent) {
	$("#selectQuestionTypes").disable();
	
}

function showFeedbackPage() {	
	$("#QuestionState2Page").hide();
	$("#QuestionFeedbackPage").show();
	$("#btnBack").show();
	$("#btnBack").unbind("click");
	$("#btnBack").bind("click",function(){
		$(this).hide();
		$("#QuestionState2Page").show();
		$("#QuestionFeedbackPage").hide();
	});
	
	window.location="ddl://giveServerScore?s=4";
}

function showSendQuestionAgain() {
	$("#QuestionState2Page").hide();
	$("#QuestionPage").show();
	$("#btnSend").show();
	$("#btnSend").attr("href","ddl://sendQuestionAgain");
	$("#selectQuestionTypes").val(ddl_questionId);
	$("#selectQuestionTypes").attr("disabled","disabled");
	$("#txtTitle").val(data["title"]);
	$("#txtTitle").attr("disabled","disabled");
	$("#btnBack").show();
	$("#btnBack").unbind("click");
	$("#btnBack").bind("click",function(){
		$(this).hide();
		$("#QuestionState2Page").show();
		$("#QuestionPage").hide();
		$("#btnSend").hide();
	});
}

// from 6
function sendQuestionAgain(devicetype,pid,rolename,userId,account,area,servername,devicename) {
	
	if(!checkInput()) {
		return;
	}
	
	  var question_type=$("#selectQuestionTypes").val();  
	  var title=$("#txtTitle").val();
	  var msg=$("#txtMsg").val();
  
	// 获取修改的问题信息 填充界面数据	
	$.ajax(host+"pushandroid/logchat_sendQuestion",{
		dataType:'json',
		data:{'questionKindId':question_type,
		'devicetype':devicetype,
		'title':title,
		'imageurl':$("#imgPicture").attr("src").replace(host,""),
		'content':msg,
		'pid':pid,
		'rolename':rolename,
		'userId':userId,
		'account':account,
		'area':area,
		'servername':servername,
		'devicename':devicename},
		cache:false,
		async:true,
		error:function(jqXHR,textStatus,errorThrown) {
			console.log('errorThrown:'+textStatus);
			showError();
		},
		success:function(data,textStatus,jqXHR) {
			console.log('status:'+textStatus);			
			handleMessage(data,6);
		},
		timeout:30000,
		type:'POST'
	}).done(function() {
		console.log('done');
	});
}

// from 5
function updateQuestion(account,area) {
	// 获取修改的问题信息 填充界面数据	
	$.ajax(host+"pushandroid/question_getPreviousQuestion",{
		dataType:'json',
		data:{
			'account':account,
			'area':area
		},
		cache:false,
		async:true,
		error:function(jqXHR,textStatus,errorThrown) {
			console.log('errorThrown:'+textStatus);
			// alert('errorThrown:'+textStatus);
			showError();
		},
		success:function(data,textStatus,jqXHR) {
			console.log('status:'+textStatus);			
			// handleMessage(data,5);
			$("#QuestionState1Page").hide();
			$("#QuestionPage").show();
			$("#btnSend").show();
			$("#btnSend").attr("href","ddl://submitUpdateQuestion");
			
			$("#btnBack").show();
			$("#btnBack").unbind("click");
			$("#btnBack").bind("click",function(){
				$("#QuestionState1Page").show();
				$("#QuestionPage").hide();
				$("#btnSend").hide();
			});

			var op="option[value='"+data["typeId"]+"']";			
			$("#selectQuestionTypes").val(data["typeId"]);
			$("#selectQuestionTypes").attr("disabled","disabled");
			$("#txtTitle").val(data["title"]);
			$("#txtTitle").attr("disabled","disabled");
			$("#txtMsg").val(data["content"]);
      	  	setPicture(data["adress"]);
		},
		timeout:30000,
		type:'GET'
	}).done(function() {
		console.log('done');
	});
}

//from 1
function deleteQuestion(account,area) {	
	$.ajax(host+"pushandroid/question_deleteQuestion",{
		dataType:'json',
		data:{
			'account':account,
			'area':area
		},
		cache:false,
		async:true,
		error:function(jqXHR,textStatus,errorThrown) {
			console.log('errorThrown:'+textStatus);
			// alert('errorThrown:'+textStatus);
			showError();
		},
		success:function(data,textStatus,jqXHR) {
			console.log('status:'+textStatus);			
			// handleMsg(data);
			
			handleMessage(data,1);
			
			// $("#QuestionPage").show();
		},
		timeout:30000,
		type:'POST'
	}).done(function() {
		console.log('done');
	});
}

// from 2
function giveServerScore(account,area,score) {	
	$.ajax(host+"pushandroid/question_giveSeverScore",{
		dataType:'json',
		data:{
			'account':account,
			'area':area,
			'serve':score
		},
		cache:false,
		async:true,
		error:function(jqXHR,textStatus,errorThrown) {
			console.log('errorThrown:'+textStatus);
			// alert('errorThrown:'+textStatus);
			showError();
		},
		success:function(data,textStatus,jqXHR) {
			console.log('status:'+textStatus);			
			// handleMsg(data);
			if(score!="4") {
				handleMessage(data,2);
			}			
			// $("#QuestionPage").show();
		},
		timeout:30000,
		type:'POST'
	}).done(function() {
		console.log('done');
	});
}

//from 3
//确认查看已经被客服关闭的问题
function closeQuestion(account,area) {	
	$.ajax(host+"pushandroid/question_updateQuestionWithLook",{
		dataType:'json',
		data:{
			'account':account,
			'area':area
		},
		cache:false,
		async:true,
		error:function(jqXHR,textStatus,errorThrown) {
			console.log('errorThrown:'+textStatus);
			// alert('errorThrown:'+textStatus);
			showError();
		},
		success:function(data,textStatus,jqXHR) {
			console.log('status:'+textStatus);			
			// handleMsg(data);
			
			handleMessage(data,3);
			
			// $("#QuestionPage").show();
		},
		timeout:30000,
		type:'POST'
	}).done(function() {
		console.log('done');
	});
}

//getQuestionState (ios wp android)
function getQuestionState(account,area,url) { 
	host=url;
	$.ajax(host+"pushandroid/question_getQuestionState",{
		dataType:'json',
		data:{
			'account':account,
			'area':area
		},
		cache:false,
		async:true,
		error:function(jqXHR,textStatus,errorThrown) {
			console.log('errorThrown:'+textStatus);
			// alert('errorThrown:'+textStatus);
			showError();
		},
		success:function(data,textStatus,jqXHR) {
			console.log('status:'+textStatus);			
			// handleMsg(data);
			
			handleQuestionStateMessage(data);
			
			initQuetionTypesSelectControl("selectQuestionTypes");
			
			// $("#QuestionPage").show();
		},
		timeout:30000,
		type:'GET'
	}).done(function() {
		console.log('done');
	});
}

// from 4
function submitUpdateQuestion(devicetype,pid,rolename,userId,account,area,servername,devicename) { 
	
	if(!checkInput()) {
		return;
	}
	
	var question_type=$("#selectQuestionTypes").val();
	var title=$("#txtTitle").val();
	var msg=$("#txtMsg").val();
	
	$.ajax(host+"pushandroid/question_updateQuestion",{
		dataType:'json',
		data:{'questionKindId':question_type,
		'devicetype':devicetype,
		'title':title,
		'imageurl':$("#imgPicture").attr("src").replace(host,""),
		'content':msg,
		'pid':pid,
		'rolename':rolename,
		'userId':userId,
		'account':account,
		'area':area,
		'servername':servername,
		'devicename':devicename},
		cache:false,
		async:true,
		error:function(jqXHR,textStatus,errorThrown) {
			console.log('errorThrown:'+textStatus);
			// alert('errorThrown:'+textStatus);
			showError();
		},
		success:function(data,textStatus,jqXHR) {
			console.log('status:'+textStatus);
			// alert(data["message"]);
			handleMessage(data,4);
		},
		timeout:30000,
		type:'POST'
	}).done(function() {
		console.log('done');
	});
}

//from 4
///submit (ios wp android)
function submitQuestion(devicetype,pid,rolename,userId,account,area,servername,devicename) {
	
	if(!checkInput()) {
		return;
	}
	
	var question_type=$("#selectQuestionTypes").val();
	var title=$("#txtTitle").val();
	var msg=$("#txtMsg").val();
	$.ajax(host+"pushandroid/question_sendFirstQuestion",{
		dataType:'json',
		data:{'questionKindId':question_type,
		'devicetype':devicetype,
		'title':title,
		'imageurl':$("#imgPicture").attr("src").replace(host,""),
		'content':msg,
		'pid':pid,
		'rolename':rolename,
		'userId':userId,
		'account':account,
		'area':area,
		'servername':servername,
		'devicename':devicename},
		cache:false,
		async:true,
		error:function(jqXHR,textStatus,errorThrown) {
			console.log('errorThrown:'+textStatus);
			// alert('errorThrown:'+textStatus);
			showError();
		},
		success:function(data,textStatus,jqXHR) {
			console.log('status:'+textStatus);
			// alert(data["message"]);
			handleMessage(data,4);
		},
		timeout:30000,
		type:'POST'
	}).done(function() {
		console.log('done');
	});
}


///questions
function getQuestionReply(account,area) {
	
	$.ajax(host+"pushandroid/question_getReplyQuestion",{
		dataType:'json',
		data:{
			'account':account,
			'area':area
		},
		cache:false,
		async:true,
		error:function(jqXHR,textStatus,errorThrown) {
			console.log('errorThrown:'+textStatus);
			showError();
		},
		password:'',
		success:function(data,textStatus,jqXHR) {
			console.log('status:'+textStatus);
			
			ddl_questionId=data["typeId"];
			$("#selectQuestionTypes").val(ddl_questionId);
			$("#selectQuestionTypes").attr("disabled","disabled");
			
			$("#txtTitle").val(data["title"]);
			$("#txtTitle").attr("disabled","disabled");
			
			$("#PlayerQuestion").text(data["playContent"]);
			$("#PlayerQuestionTime").text(data["playtime"]);
			$("#GMReplyTime").text(data["replytime"]);
			$("#GMReply").text(data["replyContent"]);
			$("#GMReplyName").text(data["replyName"]);
		},
		timeout:30000,
		type:'GET'
	}).done(function() {
		console.log('done');
	});
}

///questions
function initQuetionTypesSelectControl(id,callback) {
	
	$.ajax(host+"pushandroid/questionkind_selectFromPhone",{
		dataType:'json',
		cache:true,
		async:true,
		error:function(jqXHR,textStatus,errorThrown) {
			console.log('errorThrown:'+textStatus);
			showError();
		},
		password:'',
		success:function(data,textStatus,jqXHR) {
			console.log('status:'+textStatus);
			
			var questionTypes;
			
			handleMessage(data,callback);
			
			questionTypes=parseQuestionTypes(data["message"]);
			
			fillQuestionTypesSelect(id,questionTypes);
			
			if(callback) {callback();}
		},
		timeout:30000,
		type:'GET'
	}).done(function() {
		console.log('done');
	});
}

function fillQuestionTypesSelect(id,questionTypes) {		
	
	var select_id="#"+id;
	
	$(select_id).empty();	
	
	var options='<option value="0" selected="selected">---选择---</option>';
	
	for(var i=0,c=questionTypes.length;i<c;i++) {
		options+='<option value="'+questionTypes[i].id+'" >'+questionTypes[i].name+'</option>';
	}
	
	$(select_id).append(options);
}

function QuestionType(id,name) {
	this.id=id;
	this.name=name;
}

function parseQuestionTypes(data) {
	var questionTypes=[];
	var str_arr;			
	if(typeof(data)!="undefined") {
		str_arr=data.split(',');
	}
	if(str_arr.length>0) {
		for(var i=0,c=str_arr.length;i<c;i++) {
			var id_name_arr=str_arr[i].split('_');
			var questionType=new QuestionType(id_name_arr[0],id_name_arr[1]);	
			questionTypes.push(questionType);
		}
	}
	console.log(questionTypes);
	
	return questionTypes;
}

function showLog(data) {
	window.location="ddl://showlog?"+JSON.stringify(data);
}

function resetForm() {
	$("#selectQuestionTypes").removeAttr("disabled");
	$("#selectQuestionTypes").val(0);
	$("#txtTitle").val('');
	$("#txtTitle").removeAttr("disabled");
	$("#btnSend").attr("href","ddl://submitQuestion");
	$("#txtTitle").val("");
	$("#txtMsg").val("");
	$("#imgPicture").attr("src","img/img.png");
	
	$("#InputMessage").show();
	$("#InputMessageInfo").text("");
	
	$("#btnBack").hide();
}

function showError() {
	$(".ddl_page").hide();
	$("#ErroMessage").text("网络异常,请重试！");
	$("#ErrorPage").show();
}

function checkInput() { 
	
	if($("#selectQuestionTypes").val()=="0") {
		$("#InputMessage").show();
		$("#InputMessageInfo").text("问题类型不能为空!");
		return false;
	}
	if($("#txtTitle").val()=="") {
		$("#InputMessage").show();
		$("#InputMessageInfo").text("问题标题不能为空!");
		return false;
	}
	if($("#txtMsg").val()=="") {
		$("#InputMessage").show();
		$("#InputMessageInfo").text("问题描述不能为空!");
		return false;
	}
	
	return true;
}

function handleMessage(data,from,callback) {
	
	//测试log输出 正式环境关闭
	// showLog(data);
	
	if(!data["success"]) {
		showError();
		return;
	}  
	// (data["message"]=="1")
	else {
		if(from==1) {
			$("#QuestionState1Page").hide();
			$("#QuestionPage").show();
			$("#btnSend").show();			
		} else if(from==2) {
			$("#QuestionFeedbackPage").hide();
			$("#QuestionPage").show();
			$("#btnSend").show();
		} else if(from==3) {
			$("#QuestionState4Page").hide();
			$("#QuestionPage").show();
			$("#btnSend").show();
		} else if(from==4) {			
			$("#QuestionPage").hide();
			$("#btnSend").hide();
			$("#QuestionState1Page").show();
		} else if(from==6) {
			$("#QuestionPage").hide();
			$("#btnSend").hide();
			$("#QuestionState1Page").show();
		}
		resetForm();
	} 
}